/*
 * This file is part of Hopsworks
 * Copyright (C) 2019, Logical Clocks AB. All rights reserved
 *
 * Hopsworks is free software: you can redistribute it and/or modify it under the terms of
 * the GNU Affero General Public License as published by the Free Software Foundation,
 * either version 3 of the License, or (at your option) any later version.
 *
 * Hopsworks is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License along with this program.
 * If not, see <https://www.gnu.org/licenses/>.
 */
package io.hops.hopsworks.common.jobs.beam;

import io.hops.hopsworks.common.jobs.configuration.JobType;
import io.hops.hopsworks.common.jobs.flink.FlinkJobConfiguration;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * Beam job configuration. Specifies which runner to use.
 */
@XmlRootElement
@XmlAccessorType(XmlAccessType.NONE)
public class BeamFlinkJobConfiguration extends FlinkJobConfiguration {
  
  public BeamFlinkJobConfiguration(){
  
  }
  
  @Override
  @XmlElement(name="jobType")
  public JobType getJobType() {
    return JobType.BEAM_FLINK;
  }
  
  @Override
  @XmlElement(name="jobTypeName")
  public String getJobTypeName() {
    return JobType.BEAM_FLINK.getName();
  }
  
}
